
#include <stdio.h>

#include "config.h"
#include "popd.h"

void freecmd(char **cmd) {
	int	i;
	while(cmd[i] != NULL) {
		free(cmd[i]);
		i++;
	}
	free(cmd);
}

char **readcmd(struct pop_session *session) {
	char	*line,
		last,
		**arga;
	int	i,
		j,
		k;

	line=(char *) malloc(MAX_LINESIZE);
	if (!line)
		return(NULL);

	memset(line,0x0,MAX_LINESIZE);

	fflush((FILE *) session->out);
	/* set an alarm so we can exit if the user 
	 * falls asleep 
	 */

 	alarm(CMD_TIMEOUT); 

	/* Get a line */
	if (!fgets(line,MAX_LINESIZE,(FILE *) session->in)) {
		free(line);
		return(NULL);
	}

	alarm(0);

	/* delete spaces, tabs, newlines, carriage returns from end */
	for(i=strlen(line)-1;i>=0;--i) {
		if (line[i] == '\n' || 
				line[i] == '\r' ||
				line[i] == ' ' ||
				line[i] == 0x8)
			line[i]=0x0;
		else
			break;
	}

	/* count number of args + command */
	j=1;
	if (strlen(line) > 0) {
		for(i=1;i<strlen(line);i++) {
			if (line[i] != ' ' && 
				line[i-1] == ' ')
				j++;
		}
	}

	arga=(char **) malloc(sizeof(char *) * (j+1));
	memset(arga,0x0,sizeof(char *) * (j+1));

	if (arga == NULL) {
		free(line);
		return(NULL);
	}

	/* Now store the pointers on the arguments and 
	 * replace spaces by 0x0
	 */
	arga[0]=line;
	j=1;k=strlen(line);
	if (strlen(line) > 0) {
		for(i=1;i<k;i++) {
			if (line[i-1] == ' ') {
				line[i-1]=0x0;
				if (line[i] != ' ') {
					/* store pointer */
					arga[j]=&line[i];
					j++;
				}
			}	
		}
	}

	/* change command to lowercase */
	for (i=0;i<strlen(arga[0]);i++) {
		arga[0][i]=tolower(arga[0][i]);
	}
	return(arga);
}
